diff -urN sbcl-0.8.16/src/compiler/generic/genesis.lisp sbcl-0.8.16.patched/src/compiler/generic/genesis.lisp
--- sbcl-0.8.16/src/compiler/generic/genesis.lisp	2004-09-10 17:36:17.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/genesis.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -34,10 +34,10 @@
 
 ;;; a magic number used to identify our core files
 (defconstant core-magic
-  (logior (ash (char-code #\S) 24)
-	  (ash (char-code #\B) 16)
-	  (ash (char-code #\C) 8)
-	  (char-code #\L)))
+  (logior (ash (sb!xc:char-code #\S) 24)
+	  (ash (sb!xc:char-code #\B) 16)
+	  (ash (sb!xc:char-code #\C) 8)
+	  (sb!xc:char-code #\L)))
 
 ;;; the current version of SBCL core files
 ;;;
@@ -444,7 +444,7 @@
 			   type)))
 
 (defun make-character-descriptor (data)
-  (make-other-immediate-descriptor data sb!vm:base-char-widetag))
+  (make-other-immediate-descriptor data sb!vm:character-widetag))
 
 (defun descriptor-beyond (des offset type)
   (let* ((low (logior (+ (logandc2 (descriptor-low des) sb!vm:lowtag-mask)
@@ -608,9 +608,10 @@
 
 ;;;; copying simple objects into the cold core
 
-(defun string-to-core (string &optional (gspace *dynamic*))
+(defun base-string-to-core (string &optional (gspace *dynamic*))
   #!+sb-doc
-  "Copy string into the cold core and return a descriptor to it."
+  "Copy STRING (which must only contain STANDARD-CHARs) into the cold
+core and return a descriptor to it."
   ;; (Remember that the system convention for storage of strings leaves an
   ;; extra null byte at the end to aid in call-out to C.)
   (let* ((length (length string))
@@ -626,14 +627,7 @@
 		       (make-fixnum-descriptor length))
     (dotimes (i length)
       (setf (bvref bytes (+ offset i))
-	    ;; KLUDGE: There's no guarantee that the character
-	    ;; encoding here will be the same as the character
-	    ;; encoding on the target machine, so using CHAR-CODE as
-	    ;; we do, or a bitwise copy as CMU CL code did, is sleazy.
-	    ;; (To make this more portable, perhaps we could use
-	    ;; indices into the sequence which is used to test whether
-	    ;; a character is a STANDARD-CHAR?) -- WHN 19990817
-	    (char-code (aref string i))))
+	    (sb!xc:char-code (aref string i))))
     (setf (bvref bytes (+ offset length))
 	  0) ; null string-termination character for C
     des))
@@ -815,7 +809,7 @@
 		       (make-fixnum-descriptor 0))
     (write-wordindexed symbol sb!vm:symbol-plist-slot *nil-descriptor*)
     (write-wordindexed symbol sb!vm:symbol-name-slot
-		       (string-to-core name *dynamic*))
+		       (base-string-to-core name *dynamic*))
     (write-wordindexed symbol sb!vm:symbol-package-slot *nil-descriptor*)
     symbol))
 
@@ -1201,7 +1195,7 @@
 		       ;; because that's the way CMU CL did it; I'm
 		       ;; not sure whether there's an underlying
 		       ;; reason. -- WHN 1990826
-		       (string-to-core "NIL" *dynamic*))
+		       (base-string-to-core "NIL" *dynamic*))
     (write-wordindexed des
 		       (+ 1 sb!vm:symbol-package-slot)
 		       result)
@@ -1286,7 +1280,7 @@
       (let* ((cold-package (car cold-package-symbols-entry))
 	     (symbols (cdr cold-package-symbols-entry))
 	     (shadows (package-shadowing-symbols cold-package))
-	     (documentation (string-to-core (documentation cold-package t)))
+	     (documentation (base-string-to-core (documentation cold-package t)))
 	     (internal *nil-descriptor*)
 	     (external *nil-descriptor*)
 	     (imported-internal *nil-descriptor*)
@@ -1366,7 +1360,7 @@
 	 (res *nil-descriptor*))
     (dolist (u (package-use-list pkg))
       (when (assoc u *cold-package-symbols*)
-	(cold-push (string-to-core (package-name u)) use)))
+	(cold-push (base-string-to-core (package-name u)) use)))
     (let* ((pkg-name (package-name pkg))
 	   ;; Make the package nickname lists for the standard packages
 	   ;; be the minimum specified by ANSI, regardless of what value
@@ -1387,7 +1381,7 @@
 				 (t
 				  (package-nicknames pkg)))))
       (dolist (warm-nickname warm-nicknames)
-	(cold-push (string-to-core warm-nickname) cold-nicknames)))
+	(cold-push (base-string-to-core warm-nickname) cold-nicknames)))
 
     (cold-push (number-to-core (truncate (package-internal-symbol-count pkg)
 					 0.8))
@@ -1404,7 +1398,7 @@
     (cold-push use res)
     (cold-push (cold-intern :use) res)
 
-    (cold-push (string-to-core (package-name pkg)) res)
+    (cold-push (base-string-to-core (package-name pkg)) res)
     res))
 
 ;;;; functions and fdefinition objects
@@ -1857,7 +1851,7 @@
 (defun foreign-symbols-to-core ()
   (let ((result *nil-descriptor*))
     (maphash (lambda (symbol value)
-	       (cold-push (cold-cons (string-to-core symbol)
+	       (cold-push (cold-cons (base-string-to-core symbol)
 				     (number-to-core value))
 			  result))
 	     *cold-foreign-symbol-table*)
@@ -1998,21 +1992,21 @@
 	      (depthoid (descriptor-fixnum depthoid-des)))
 	  (unless (= length old-length)
 	    (error "cold loading a reference to class ~S when the compile~%~
-		   time length was ~S and current length is ~S"
+                    time length was ~S and current length is ~S"
 		   name
 		   length
 		   old-length))
 	  (unless (equal inherits-list old-inherits-list)
 	    (error "cold loading a reference to class ~S when the compile~%~
-		   time inherits were ~S~%~
-		   and current inherits are ~S"
+                    time inherits were ~S~%~
+                    and current inherits are ~S"
 		   name
 		   inherits-list
 		   old-inherits-list))
 	  (unless (= depthoid old-depthoid)
 	    (error "cold loading a reference to class ~S when the compile~%~
-		   time inheritance depthoid was ~S and current inheritance~%~
-		   depthoid is ~S"
+                    time inheritance depthoid was ~S and current inheritance~%~
+                    depthoid is ~S"
 		   name
 		   depthoid
 		   old-depthoid)))
@@ -2105,12 +2099,16 @@
 
 ;;;; cold fops for loading vectors
 
-(clone-cold-fop (fop-string)
-		(fop-small-string)
+(clone-cold-fop (fop-base-string)
+		(fop-small-base-string)
   (let* ((len (clone-arg))
 	 (string (make-string len)))
     (read-string-as-bytes *fasl-input-stream* string)
-    (string-to-core string)))
+    (base-string-to-core string)))
+
+(clone-cold-fop (fop-character-string)
+		(fop-small-character-string)
+  (bug "CHARACTER-STRING dumped by cross-compiler."))
 
 (clone-cold-fop (fop-vector)
 		(fop-small-vector)
@@ -2989,7 +2987,7 @@
 	  ;; (We write each character as a word in order to avoid
 	  ;; having to think about word alignment issues in the
 	  ;; sbcl-0.7.8 version of coreparse.c.)
-	  (write-word (char-code char))))
+	  (write-word (sb!xc:char-code char))))
 
       ;; Write the New Directory entry header.
       (write-word new-directory-core-entry-type-code)
diff -urN sbcl-0.8.16/src/compiler/generic/interr.lisp sbcl-0.8.16.patched/src/compiler/generic/interr.lisp
--- sbcl-0.8.16/src/compiler/generic/interr.lisp	2003-07-16 10:26:02.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/interr.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -61,6 +61,10 @@
    "Object is not of type STRING.")
   (object-not-base-string
    "Object is not of type BASE-STRING.")
+  (object-not-vector-nil
+   "Object is not of type (VECTOR NIL).")
+  (object-not-character-string
+   "Object is not of type (VECTOR CHARACTER).")
   (object-not-bit-vector
    "Object is not of type BIT-VECTOR.")
   (object-not-array
@@ -130,8 +134,8 @@
    "Object is not a WEAK-POINTER.")
   (object-not-instance
    "Object is not a INSTANCE.")
-  (object-not-base-char
-   "Object is not of type BASE-CHAR.")
+  (object-not-character
+   "Object is not a CHARACTER.")
   (nil-fun-returned
    "A function with declared result type NIL returned.")
   (nil-array-accessed
diff -urN sbcl-0.8.16/src/compiler/generic/late-type-vops.lisp sbcl-0.8.16.patched/src/compiler/generic/late-type-vops.lisp
--- sbcl-0.8.16/src/compiler/generic/late-type-vops.lisp	2004-04-08 11:25:09.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/late-type-vops.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -66,7 +66,8 @@
 
 (!define-type-vops simple-string-p check-simple-string nil
     object-not-simple-string-error
-  (simple-base-string-widetag simple-array-nil-widetag))
+  (simple-character-string-widetag
+   simple-base-string-widetag simple-array-nil-widetag))
 
 (macrolet
     ((define-simple-array-type-vops ()
@@ -83,9 +84,9 @@
 		  *specialized-array-element-type-properties*))))
   (define-simple-array-type-vops))
 
-(!define-type-vops base-char-p check-base-char base-char
-    object-not-base-char-error
-  (base-char-widetag))
+(!define-type-vops characterp check-character character
+    object-not-character-error
+  (character-widetag))
 
 (!define-type-vops system-area-pointer-p check-system-area-pointer
       system-area-pointer
@@ -109,11 +110,14 @@
   (funcallable-instance-header-widetag))
 
 (!define-type-vops array-header-p nil nil nil
-  (simple-array-widetag complex-base-string-widetag complex-bit-vector-widetag
+  (simple-array-widetag
+   complex-character-string-widetag
+   complex-base-string-widetag complex-bit-vector-widetag
    complex-vector-widetag complex-array-widetag complex-vector-nil-widetag))
 
 (!define-type-vops stringp check-string nil object-not-string-error
-  (simple-base-string-widetag complex-base-string-widetag
+  (simple-character-string-widetag complex-character-string-widetag
+   simple-base-string-widetag complex-base-string-widetag
    simple-array-nil-widetag complex-vector-nil-widetag))
 
 (!define-type-vops base-string-p check-base-string nil object-not-base-string-error
@@ -127,6 +131,10 @@
     object-not-vector-nil-error
   (simple-array-nil-widetag complex-vector-nil-widetag))
 
+(!define-type-vops character-string-p check-character-string nil
+    object-not-character-string-error
+  (simple-character-string-widetag complex-character-string-widetag))
+
 (!define-type-vops vectorp check-vector nil object-not-vector-error
   (complex-vector-widetag .
    #.(append
diff -urN sbcl-0.8.16/src/compiler/generic/primtype.lisp sbcl-0.8.16.patched/src/compiler/generic/primtype.lisp
--- sbcl-0.8.16/src/compiler/generic/primtype.lisp	2004-08-06 20:43:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/primtype.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -66,7 +66,7 @@
 
 ;;; other primitive immediate types
 (/show0 "primtype.lisp 68")
-(!def-primitive-type base-char (base-char-reg any-reg))
+(!def-primitive-type character (character-reg any-reg))
 
 ;;; primitive pointer types
 (/show0 "primtype.lisp 73")
@@ -304,6 +304,13 @@
 	 (ecase (named-type-name type)
 	   ((t *) (values *backend-t-primitive-type* t))
 	   ((nil) (any))))
+	(character-set-type
+	 (let ((pairs (character-set-type-pairs type)))
+	   (if (and (= (length pairs) 1)
+		    (= (caar pairs) 0)
+		    (= (cdar pairs) (1- sb!xc:char-code-limit)))
+	       (exactly character)
+	       (part-of character))))
 	(built-in-classoid
 	 (case (classoid-name type)
 	   ((complex function instance
@@ -311,8 +318,6 @@
 	    (values (primitive-type-or-lose (classoid-name type)) t))
 	   (funcallable-instance
 	    (part-of function))
-	   (base-char
-	    (exactly base-char))
 	   (cons-type
 	    (part-of list))
 	   (t
diff -urN sbcl-0.8.16/src/compiler/generic/vm-array.lisp sbcl-0.8.16.patched/src/compiler/generic/vm-array.lisp
--- sbcl-0.8.16/src/compiler/generic/vm-array.lisp	2004-08-10 02:20:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/vm-array.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -68,9 +68,13 @@
 		    ;; (SIMPLE-BASE-STRINGs are stored with an extra
 		    ;; trailing #\NULL for convenience in calling out
 		    ;; to C.)
-		    :n-pad-elements 1
+	            :n-pad-elements 1
 	            :complex-typecode #.sb!vm:complex-base-string-widetag
 	            :importance 17)
+	 (character ,(code-char 0) 32 simple-character-string
+		    :n-pad-elements 1
+	            :complex-typecode #.sb!vm:complex-character-string-widetag
+	            :importance 17)
 	 (single-float 0.0f0 32 simple-array-single-float
 	  :importance 6)
 	 (double-float 0.0d0 64 simple-array-double-float
diff -urN sbcl-0.8.16/src/compiler/generic/vm-fndb.lisp sbcl-0.8.16.patched/src/compiler/generic/vm-fndb.lisp
--- sbcl-0.8.16/src/compiler/generic/vm-fndb.lisp	2004-08-10 17:38:13.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/vm-fndb.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -22,6 +22,7 @@
 	   complex-vector-p
 	   base-char-p %standard-char-p %instancep
 	   base-string-p simple-base-string-p
+	   character-string-p simple-character-string-p
 	   array-header-p
 	   simple-array-p simple-array-nil-p vector-nil-p
 	   simple-array-unsigned-byte-2-p
diff -urN sbcl-0.8.16/src/compiler/generic/vm-tran.lisp sbcl-0.8.16.patched/src/compiler/generic/vm-tran.lisp
--- sbcl-0.8.16/src/compiler/generic/vm-tran.lisp	2004-08-17 00:52:00.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/vm-tran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -36,6 +36,7 @@
 ;;;; character support
 
 ;;; In our implementation there are really only BASE-CHARs.
+#+nil
 (define-source-transform characterp (obj)
   `(base-char-p ,obj))
 
@@ -48,6 +49,7 @@
 	(give-up-ir1-transform)
 	`(etypecase string
 	  ((simple-array character (*)) (data-vector-ref string index))
+	  ((simple-array base-char (*)) (data-vector-ref string index))
 	  ((simple-array nil (*)) (data-vector-ref string index))))))
 
 (deftransform hairy-data-vector-ref ((array index) (array t) *)
@@ -98,6 +100,8 @@
 	`(etypecase string
 	  ((simple-array character (*))
 	   (data-vector-set string index new-value))
+	  ((simple-array base-char (*))
+	   (data-vector-set string index new-value))
 	  ((simple-array nil (*))
 	   (data-vector-set string index new-value))))))
 
@@ -228,7 +232,7 @@
 					  (length bit-array-2)
                                           (length result-bit-array))
                                  (error "Argument and/or result bit arrays are not the same length:~
-			 ~%  ~S~%  ~S  ~%  ~S"
+                         ~%  ~S~%  ~S  ~%  ~S"
                                         bit-array-1
 					bit-array-2
 					result-bit-array))))
@@ -278,7 +282,7 @@
 	 '((unless (= (length bit-array)
 		      (length result-bit-array))
 	     (error "Argument and result bit arrays are not the same length:~
-	     	     ~%  ~S~%  ~S"
+                     ~%  ~S~%  ~S"
 		    bit-array result-bit-array))))
     (let ((length (length result-bit-array)))
       (if (= length 0)
diff -urN sbcl-0.8.16/src/compiler/generic/vm-typetran.lisp sbcl-0.8.16.patched/src/compiler/generic/vm-typetran.lisp
--- sbcl-0.8.16/src/compiler/generic/vm-typetran.lisp	2004-08-10 02:20:45.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/generic/vm-typetran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -17,9 +17,9 @@
 
 ;;; These type predicates are used to implement simple cases of TYPEP.
 ;;; They shouldn't be used explicitly.
-(define-type-predicate base-char-p base-char)
 (define-type-predicate base-string-p base-string)
 (define-type-predicate bignump bignum)
+(define-type-predicate character-string-p (vector character))
 (define-type-predicate complex-double-float-p (complex double-float))
 (define-type-predicate complex-single-float-p (complex single-float))
 #!+long-float
@@ -93,6 +93,7 @@
 (define-type-predicate simple-array-complex-long-float-p
 		       (simple-array (complex long-float) (*)))
 (define-type-predicate simple-base-string-p simple-base-string)
+(define-type-predicate simple-character-string-p (simple-array character (*)))
 (define-type-predicate system-area-pointer-p system-area-pointer)
 (define-type-predicate unsigned-byte-32-p (unsigned-byte 32))
 (define-type-predicate signed-byte-32-p (signed-byte 32))
diff -urN sbcl-0.8.16/src/compiler/ir1tran.lisp sbcl-0.8.16.patched/src/compiler/ir1tran.lisp
--- sbcl-0.8.16/src/compiler/ir1tran.lisp	2004-10-20 10:15:31.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/ir1tran.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -239,6 +239,7 @@
 	       ;; can't contain other objects
 	       (unless (typep value
 			      '(or #-sb-xc-host unboxed-array
+				   #+sb-xc-host (simple-array (unsigned-byte 8) (*))
 				   symbol
 				   number
 				   character
@@ -1067,7 +1068,7 @@
 		(functional
 		 (when (policy *lexenv* (>= speed inhibit-warnings))
 		   (compiler-notify "ignoring ~A declaration not at ~
-				     definition of local function:~%  ~S"
+                                     definition of local function:~%  ~S"
 				    sense name)))
 		(global-var
 		 (push (cons name (make-new-inlinep found sense))
diff -urN sbcl-0.8.16/src/compiler/ppc/array.lisp sbcl-0.8.16.patched/src/compiler/ppc/array.lisp
--- sbcl-0.8.16/src/compiler/ppc/array.lisp	2004-08-10 16:20:48.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/ppc/array.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -110,10 +110,11 @@
        (:results (result :scs ,scs))
        (:result-types ,element-type)))))
   (def-data-vector-frobs simple-base-string byte-index
-    base-char base-char-reg)
+    character character-reg)
+  (def-data-vector-frobs simple-character-string word-index
+    character character-reg)
   (def-data-vector-frobs simple-vector word-index
     * descriptor-reg any-reg)
-
   (def-data-vector-frobs simple-array-unsigned-byte-7 byte-index
     positive-fixnum unsigned-reg)
   (def-data-vector-frobs simple-array-unsigned-byte-8 byte-index
@@ -134,7 +135,6 @@
   (def-data-vector-frobs simple-array-signed-byte-32 word-index
     signed-num signed-reg))
 
-
 ;;; Integer vectors whos elements are smaller than a byte.  I.e. bit, 2-bit,
 ;;; and 4-bit vectors.
 ;;; 
diff -urN sbcl-0.8.16/src/compiler/ppc/c-call.lisp sbcl-0.8.16.patched/src/compiler/ppc/c-call.lisp
--- sbcl-0.8.16/src/compiler/ppc/c-call.lisp	2003-09-15 11:21:38.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/ppc/c-call.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -303,7 +303,7 @@
   (:translate foreign-symbol-address)
   (:policy :fast-safe)
   (:args)
-  (:arg-types (:constant simple-base-string))
+  (:arg-types (:constant simple-string))
   (:info foreign-symbol)
   (:results (res :scs (sap-reg)))
   (:result-types system-area-pointer)
diff -urN sbcl-0.8.16/src/compiler/ppc/char.lisp sbcl-0.8.16.patched/src/compiler/ppc/char.lisp
--- sbcl-0.8.16/src/compiler/ppc/char.lisp	2003-11-11 00:26:38.000000000 +0100
+++ sbcl-0.8.16.patched/src/compiler/ppc/char.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -14,35 +14,35 @@
 ;;;; Moves and coercions:
 
 ;;; Move a tagged char to an untagged representation.
-(define-vop (move-to-base-char)
+(define-vop (move-to-character)
   (:args (x :scs (any-reg descriptor-reg)))
-  (:results (y :scs (base-char-reg)))
+  (:results (y :scs (character-reg)))
   (:note "character untagging")
   (:generator 1
     (inst srwi y x n-widetag-bits)))
 
-(define-move-vop move-to-base-char :move
-  (any-reg descriptor-reg) (base-char-reg))
+(define-move-vop move-to-character :move
+  (any-reg descriptor-reg) (character-reg))
 
 
 ;;; Move an untagged char to a tagged representation.
-(define-vop (move-from-base-char)
-  (:args (x :scs (base-char-reg)))
+(define-vop (move-from-character)
+  (:args (x :scs (character-reg)))
   (:results (y :scs (any-reg descriptor-reg)))
   (:note "character tagging")
   (:generator 1
     (inst slwi y x n-widetag-bits)
-    (inst ori y y base-char-widetag)))
+    (inst ori y y character-widetag)))
 
-(define-move-vop move-from-base-char :move
-  (base-char-reg) (any-reg descriptor-reg))
+(define-move-vop move-from-character :move
+  (character-reg) (any-reg descriptor-reg))
 
-;;; Move untagged base-char values.
-(define-vop (base-char-move)
+;;; Move untagged character values.
+(define-vop (character-move)
   (:args (x :target y
-	    :scs (base-char-reg)
+	    :scs (character-reg)
 	    :load-if (not (location= x y))))
-  (:results (y :scs (base-char-reg)
+  (:results (y :scs (character-reg)
 	       :load-if (not (location= x y))))
   (:note "character move")
   (:effects)
@@ -50,32 +50,32 @@
   (:generator 0
     (move y x)))
 
-(define-move-vop base-char-move :move
-  (base-char-reg) (base-char-reg))
+(define-move-vop character-move :move
+  (character-reg) (character-reg))
 
-;;; Move untagged base-char arguments/return-values.
-(define-vop (move-base-char-arg)
+;;; Move untagged character arguments/return-values.
+(define-vop (move-character-arg)
   (:args (x :target y
-	    :scs (base-char-reg))
+	    :scs (character-reg))
 	 (fp :scs (any-reg)
-	     :load-if (not (sc-is y base-char-reg))))
+	     :load-if (not (sc-is y character-reg))))
   (:results (y))
   (:note "character arg move")
   (:generator 0
     (sc-case y
-      (base-char-reg
+      (character-reg
        (move y x))
-      (base-char-stack
+      (character-stack
        (storew x fp (tn-offset y))))))
 
-(define-move-vop move-base-char-arg :move-arg
-  (any-reg base-char-reg) (base-char-reg))
+(define-move-vop move-character-arg :move-arg
+  (any-reg character-reg) (character-reg))
 
 
-;;; Use standard MOVE-ARG + coercion to move an untagged base-char
+;;; Use standard MOVE-ARG + coercion to move an untagged character
 ;;; to a descriptor passing location.
 (define-move-vop move-arg :move-arg
-  (base-char-reg) (any-reg descriptor-reg))
+  (character-reg) (any-reg descriptor-reg))
 
 
 
@@ -84,8 +84,8 @@
 (define-vop (char-code)
   (:translate char-code)
   (:policy :fast-safe)
-  (:args (ch :scs (base-char-reg) :target res))
-  (:arg-types base-char)
+  (:args (ch :scs (character-reg) :target res))
+  (:arg-types character)
   (:results (res :scs (any-reg)))
   (:result-types positive-fixnum)
   (:generator 1
@@ -96,17 +96,17 @@
   (:policy :fast-safe)
   (:args (code :scs (any-reg) :target res))
   (:arg-types positive-fixnum)
-  (:results (res :scs (base-char-reg)))
-  (:result-types base-char)
+  (:results (res :scs (character-reg)))
+  (:result-types character)
   (:generator 1
     (inst srwi res code 2)))
 
 
-;;; Comparison of base-chars.
-(define-vop (base-char-compare)
-  (:args (x :scs (base-char-reg))
-	 (y :scs (base-char-reg)))
-  (:arg-types base-char base-char)
+;;; Comparison of characters.
+(define-vop (character-compare)
+  (:args (x :scs (character-reg))
+	 (y :scs (character-reg)))
+  (:arg-types character character)
   (:conditional)
   (:info target not-p)
   (:policy :fast-safe)
@@ -116,21 +116,21 @@
     (inst cmplw x y)
     (inst b? (if not-p not-condition condition) target)))
 
-(define-vop (fast-char=/base-char base-char-compare)
+(define-vop (fast-char=/character character-compare)
   (:translate char=)
   (:variant :eq :ne))
 
-(define-vop (fast-char</base-char base-char-compare)
+(define-vop (fast-char</character character-compare)
   (:translate char<)
   (:variant :lt :ge))
 
-(define-vop (fast-char>/base-char base-char-compare)
+(define-vop (fast-char>/character character-compare)
   (:translate char>)
   (:variant :gt :le))
 
-(define-vop (base-char-compare/c)
-  (:args (x :scs (base-char-reg)))
-  (:arg-types base-char (:constant base-char))
+(define-vop (character-compare/c)
+  (:args (x :scs (character-reg)))
+  (:arg-types character (:constant character))
   (:conditional)
   (:info target not-p y)
   (:policy :fast-safe)
@@ -140,15 +140,15 @@
     (inst cmplwi x (sb!xc:char-code y))
     (inst b? (if not-p not-condition condition) target)))
 
-(define-vop (fast-char=/base-char/c base-char-compare/c)
+(define-vop (fast-char=/character/c character-compare/c)
   (:translate char=)
   (:variant :eq :ne))
 
-(define-vop (fast-char</base-char/c base-char-compare/c)
+(define-vop (fast-char</character/c character-compare/c)
   (:translate char<)
   (:variant :lt :ge))
 
-(define-vop (fast-char>/base-char/c base-char-compare/c)
+(define-vop (fast-char>/character/c character-compare/c)
   (:translate char>)
   (:variant :gt :le))
 
diff -urN sbcl-0.8.16/src/compiler/ppc/move.lisp sbcl-0.8.16.patched/src/compiler/ppc/move.lisp
--- sbcl-0.8.16/src/compiler/ppc/move.lisp	2003-10-29 07:38:40.000000000 +0100
+++ sbcl-0.8.16.patched/src/compiler/ppc/move.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -17,15 +17,15 @@
        (load-symbol y val))
       (character
        (inst lr y (logior (ash (char-code val) n-widetag-bits)
-			  base-char-widetag))))))
+			  character-widetag))))))
 
 (define-move-fun (load-number 1) (vop x y)
   ((immediate zero)
    (signed-reg unsigned-reg))
   (inst lr y (tn-value x)))
 
-(define-move-fun (load-base-char 1) (vop x y)
-  ((immediate) (base-char-reg))
+(define-move-fun (load-character 1) (vop x y)
+  ((immediate) (character-reg))
   (inst li y (char-code (tn-value x))))
 
 (define-move-fun (load-system-area-pointer 1) (vop x y)
@@ -41,7 +41,7 @@
   (load-stack-tn y x))
 
 (define-move-fun (load-number-stack 5) (vop x y)
-  ((base-char-stack) (base-char-reg)
+  ((character-stack) (character-reg)
    (sap-stack) (sap-reg)
    (signed-stack) (signed-reg)
    (unsigned-stack) (unsigned-reg))
@@ -53,7 +53,7 @@
   (store-stack-tn y x))
 
 (define-move-fun (store-number-stack 5) (vop x y)
-  ((base-char-reg) (base-char-stack)
+  ((character-reg) (character-stack)
    (sap-reg) (sap-stack)
    (signed-reg) (signed-stack)
    (unsigned-reg) (unsigned-stack))
diff -urN sbcl-0.8.16/src/compiler/ppc/vm.lisp sbcl-0.8.16.patched/src/compiler/ppc/vm.lisp
--- sbcl-0.8.16/src/compiler/ppc/vm.lisp	2004-08-07 14:20:10.000000000 +0200
+++ sbcl-0.8.16.patched/src/compiler/ppc/vm.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -141,7 +141,7 @@
   ;; The non-descriptor stacks.
   (signed-stack non-descriptor-stack) ; (signed-byte 32)
   (unsigned-stack non-descriptor-stack) ; (unsigned-byte 32)
-  (base-char-stack non-descriptor-stack) ; non-descriptor characters.
+  (character-stack non-descriptor-stack) ; non-descriptor characters.
   (sap-stack non-descriptor-stack) ; System area pointers.
   (single-stack non-descriptor-stack) ; single-floats
   (double-stack non-descriptor-stack
@@ -169,11 +169,11 @@
    :alternate-scs (control-stack))
 
   ;; Non-Descriptor characters
-  (base-char-reg registers
+  (character-reg registers
    :locations #.non-descriptor-regs
    :constant-scs (immediate)
    :save-p t
-   :alternate-scs (base-char-stack))
+   :alternate-scs (character-stack))
 
   ;; Non-Descriptor SAP's (arbitrary pointers into address space)
   (sap-reg registers
@@ -332,11 +332,19 @@
       (immediate-constant "Immed"))))
 
 ;;; The loader uses this to convert alien names to the form they
-;;; occur in the symbol table.  This is ELF, so do nothing.
+;;; occur in the symbol table.
 
 (defun extern-alien-name (name)
-  (declare (type simple-base-string name))
-  ;; Darwin is non-ELF, and needs a _ prefix
-  #!+darwin (concatenate 'string "_" name)
-  ;; The other (ELF) ports currently don't need any prefix
-  #!-darwin name)
+  (declare (type string name))
+  ;; Darwin is non-ELF, and needs a _ prefix. The other (ELF) ports
+  ;; currently don't need any prefix.
+  (flet ((maybe-prefix (name)
+            #!+darwin (concatenate 'simple-base-string "_" name)
+            #!-darwin name))
+    (typecase name
+      (simple-base-string (maybe-prefix name))
+      (base-string (coerce (maybe-prefix name) 'simple-base-string))
+      (t
+       (handler-case (coerce (maybe-prefix name) 'simple-base-string)
+        (type-error ()
+          (error "invalid external alien name: ~S" name)))))))
